
<!-- [![Build Status](https://travis-ci.org/yuangu/sxtwl_cpp.svg?branch=master)](https://travis-ci.org/yuangu/sxtwl_cpp) -->

[![Build status](https://ci.appveyor.com/api/projects/status/i78d0p0dggp9v475?svg=true)](https://ci.appveyor.com/project/yuangu/sxtwl-cpp)


本项目 [GitHub](https://github.com/yuangu/sxtwl_cpp) / [Gitee（码云）](https://gitee.com/yuangu/sxtwl)。

## 详细介绍

sxtwl_cpp是参考[寿星天文历](http://www.nongli.net/sxwnl/)并使用C++实现日历库。因为其依据天文历法算法实现，故其可查询范围广(BC722年以后与实历相符)。支持Android、IOS、Windows、MacOS、Linux等平台。使用swig暴露接口给python,lua,java等语言使用。
最新版本v2.x重新设计接口，让sxtwl得到了将近一倍以上的性能提升。接口和以前版本也有一点不一样。 



## 联系及广告

+ 如有对日历，易学等感觉兴趣的同学想入群讨论的或使用此项目过程中遇到困难的同学，另或有需要付费类的其它技术支持及商务合作（如开发APP等）可加微信（微信号: yyguzi 或扫码）。

作者微信二维码:

![微信二维码](https://gitee.com/yuangu/sxtwl/raw/master/doc/img/WechatIMG5.jpeg)  

请您扫码关注作者的《通俗万年历公众号》 (广告):

![通俗万年历](https://gitee.com/yuangu/sxtwl/raw/master/doc/img/qrcode.jpg)



## 特性

* 易于使用：使用cmake管理工程
* 多平台支持
* 查询范围广
* 免除附带表数据

## 用途

*  做为航海历使用。（注：虽然叫做农历，其实和农业生产一点关系都没有。但和航海有关）
*  命理研究
*  考古工作
*  与农历相关的数据提供 
*  天文研究
*  其它用途等我再想一下。


## 构建方法（C++、C#、PHP、Lua等）

如果想直接使用二进制包请略过
如有自已构建需求的请参考[构建文档](doc/如何构建.md)


### 二进制安装及使用事例
我将一些常用的日历相关的算法都写成例子。如果您觉得关于此库的使用方法，没有讲清楚的，可以+微信告知作者提供。

+ #### Python用户专享文档
    点击[Python安装及事例文档](python/README.md)阅读文档

+ #### C/C++用户专享文档
    点击[C/C++安装及事例文档](doc/如何构建.md)阅读文档

+ #### java用户专享文档
   点击[java安装及事例文档](doc/如何构建.md)阅读文档 

+ #### php用户专享文档
     点击[php安装及事例文档](doc/如何构建.md)阅读文档

+ #### lua用户专享文档
   点击[Python安装及事例文档](doc/如何构建.md)阅读文档

+ #### C#用户专享文档
    点击[C#安装及事例文档](doc/如何构建.md)阅读文档

+  #### C语言用户专享文档 
    注：如有需要显示给其它语言调用的用户，可以使用此版本。目前只提供静态库的生成。
    另外，导接的接口可参考 c/sxtwl_c.h
    点击[C语言安装及事例文档](doc/如何构建.md)阅读文档


## 最后
* 如果您喜欢本项目或者发现该库的bug可加微信留言
* 如果您使用了此项目的代码，为了表示对寿星天文历原作者的尊重，请您项目适当的位置表达对许剑伟先生感谢



